import { ParserOptions } from './parser';
import OpenAPIPlugin, { OpenAPIPluginOptions } from './plugin';
import { TransformerOptions } from './transformer';
export interface RunnerOption {
    plugins?: OpenAPIPlugin<OpenAPIPluginOptions>[];
    namespaces: ParserOptions[];
}
/**
 * OpenAPI Runner
 */
export default class OpenAPIRunner {
    /**
     * run single transformer
     * @param options transformer options
     */
    private static runSingle;
    /**
     * run transformers
     * @param options single runner options or multiple transformer options
     */
    static run(options: RunnerOption | TransformerOptions[]): Promise<void>;
}
