"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const transformer_1 = __importDefault(require("./transformer"));
/**
 * OpenAPI Runner
 */
class OpenAPIRunner {
    /**
     * run single transformer
     * @param options transformer options
     */
    static runSingle(options) {
        return __awaiter(this, void 0, void 0, function* () {
            const transformer = new transformer_1.default(options);
            yield transformer.transform();
        });
    }
    /**
     * run transformers
     * @param options single runner options or multiple transformer options
     */
    static run(options) {
        return __awaiter(this, void 0, void 0, function* () {
            if (Array.isArray(options)) {
                yield Promise.all(options.map((option) => __awaiter(this, void 0, void 0, function* () { return yield OpenAPIRunner.runSingle(option); })));
            }
            else {
                const { plugins = [], namespaces } = options;
                yield Promise.all(namespaces.map((option) => __awaiter(this, void 0, void 0, function* () {
                    return yield OpenAPIRunner.runSingle(Object.assign({ plugins }, option));
                })));
            }
        });
    }
}
exports.default = OpenAPIRunner;
